/* Generated by wayland-scanner 1.21.0 */

#ifndef TEST_DRIVER_SERVER_PROTOCOL_H
#define TEST_DRIVER_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_test_driver The test_driver protocol
 * @section page_ifaces_test_driver Interfaces
 * - @subpage page_iface_test_driver - 
 */
struct test_driver;
struct wl_callback;
struct wl_surface;

#ifndef TEST_DRIVER_INTERFACE
#define TEST_DRIVER_INTERFACE
/**
 * @page page_iface_test_driver test_driver
 * @section page_iface_test_driver_api API
 * See @ref iface_test_driver.
 */
/**
 * @defgroup iface_test_driver The test_driver interface
 */
extern const struct wl_interface test_driver_interface;
#endif

/**
 * @ingroup iface_test_driver
 * @struct test_driver_interface
 */
struct test_driver_interface {
	/**
	 */
	void (*sync_actor_destroyed)(struct wl_client *client,
				     struct wl_resource *resource,
				     uint32_t callback,
				     struct wl_resource *surface);
	/**
	 */
	void (*sync_effects_completed)(struct wl_client *client,
				       struct wl_resource *resource,
				       uint32_t callback,
				       struct wl_resource *surface);
	/**
	 */
	void (*sync_point)(struct wl_client *client,
			   struct wl_resource *resource,
			   uint32_t sequence,
			   struct wl_resource *surface);
	/**
	 */
	void (*verify_view)(struct wl_client *client,
			    struct wl_resource *resource,
			    uint32_t callback,
			    uint32_t sequence);
};

#define TEST_DRIVER_SYNC_EVENT 0
#define TEST_DRIVER_PROPERTY 1

/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_EVENT_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_PROPERTY_SINCE_VERSION 1

/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_ACTOR_DESTROYED_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_EFFECTS_COMPLETED_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_SYNC_POINT_SINCE_VERSION 1
/**
 * @ingroup iface_test_driver
 */
#define TEST_DRIVER_VERIFY_VIEW_SINCE_VERSION 1

/**
 * @ingroup iface_test_driver
 * Sends an sync_event event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
test_driver_send_sync_event(struct wl_resource *resource_, uint32_t sequence)
{
	wl_resource_post_event(resource_, TEST_DRIVER_SYNC_EVENT, sequence);
}

/**
 * @ingroup iface_test_driver
 * Sends an property event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
test_driver_send_property(struct wl_resource *resource_, const char *name, const char *value)
{
	wl_resource_post_event(resource_, TEST_DRIVER_PROPERTY, name, value);
}

#ifdef  __cplusplus
}
#endif

#endif
